package org.openepics.names.rest.beans.element;

import java.io.Serializable;
import java.util.Objects;
import java.util.UUID;

import io.swagger.v3.oas.annotations.media.Schema;

public class NameElementCommandUpdate extends NameElementCommandCreate implements Serializable {

    /**
     *
     */
    private static final long serialVersionUID = -2695766212812986367L;

    @Schema(description = "Identity (uuid) of the name entry. Value is created server-side.")
    private UUID uuid;

    /**
     * Public constructor.
     */
    public NameElementCommandUpdate() {
    }

    /**
     * Public constructor.
     *
     * @param uuid uuid
     * @param parentSystemStructure parent system structure uuid
     * @param parentDeviceStructure parent device structure uuid
     * @param index index
     * @param description description
     * @param comment comment
     */
    public NameElementCommandUpdate(
            UUID uuid, UUID parentSystemStructure, UUID parentDeviceStructure, String index,
            String description, String comment) {
        super(parentSystemStructure, parentDeviceStructure, index, description, comment);
        this.uuid = uuid;
    }

    public UUID getUuid() {
        return uuid;
    }
    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;

        return equals ((NameElementCommandUpdate) obj);
    }

    public boolean equals(NameElementCommandUpdate other) {
        if (other == null)
            return false;

        if (!super.equals(other)) {
            return false;
        }

        if (getUuid() == null) {
            if (other.getUuid() != null)
                return false;
        } else if (!getUuid().equals(other.getUuid()))
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        return Objects.hash(getUuid());
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        sb.append("\"uuid\": "                    + getUuid());
        sb.append(", \"parentSystemStructure\": " + getParentSystemStructure());
        sb.append(", \"parentDeviceStructure\": " + getParentDeviceStructure());
        sb.append(", \"index\": "                 + getIndex());
        sb.append(", \"description\": "           + getDescription());
        sb.append(", \"comment\": "               + getComment());
        sb.append("}");
        return sb.toString();
    }

}
